buildFilesystem.sh 8.0 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239
  1. #!/bin/bash
  2. set -x
  3. set -e
  4. # Build fs, image
  5. # This file is part of PrawnOS (https://www.prawnos.com)
  6. # Copyright (c) 2018 Hal Emmerich <hal@halemmerich.com>
  7. # PrawnOS is free software: you can redistribute it and/or modify
  8. # it under the terms of the GNU General Public License version 2
  9. # as published by the Free Software Foundation.
  10. # PrawnOS is distributed in the hope that it will be useful,
  11. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  12. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  13. # GNU General Public License for more details.
  14. # You should have received a copy of the GNU General Public License
  15. # along with PrawnOS. If not, see <https://www.gnu.org/licenses/>.
  16. #Ensure Sudo
  17. if [ ! $UID = "0" ]
  18. then
  19. echo "Please run this script with sudo, or as root:"
  20. echo "sudo $0 $*"
  21. exit 1
  22. fi
  23. if [ -z "$1" ]
  24. then
  25. echo "No kernel version supplied"
  26. exit 1
  27. fi
  28. if [ -z "$2" ]
  29. then
  30. echo "No debian suite supplied"
  31. exit 1
  32. fi
  33. if [ -z "$3" ]
  34. then
  35. echo "No base file system image filename supplied"
  36. exit 1
  37. fi
  38. if [ -z "$4" ]
  39. then
  40. echo "No prawnos_root path supplied"
  41. exit 1
  42. fi
  43. KVER=$1
  44. DEBIAN_SUITE=$2
  45. BASE=$3
  46. PRAWNOS_ROOT=$4
  47. outmnt=$(mktemp -d -p `pwd`)
  48. outdev=/dev/loop5
  49. install_resources=resources/InstallResources
  50. build_resources=resources/BuildResources
  51. script_resources=scripts/
  52. package_lists=$script_resources/package_lists.sh
  53. # Import the package lists
  54. source $package_lists
  55. #A hacky way to ensure the loops are properly unmounted and the temp files are properly deleted.
  56. #Without this, a reboot is sometimes required to properly clean the loop devices and ensure a clean build
  57. cleanup() {
  58. set +e
  59. umount -l $outmnt > /dev/null 2>&1
  60. rmdir $outmnt > /dev/null 2>&1
  61. losetup -d $outdev > /dev/null 2>&1
  62. umount -l $outmnt > /dev/null 2>&1
  63. rmdir $outmnt > /dev/null 2>&1
  64. losetup -d $outdev > /dev/null 2>&1
  65. #delete the base file, we didn't complete our work
  66. rm -rf $BASE
  67. echo "FILESYSTEM BUILD FAILED"
  68. exit 1
  69. }
  70. trap cleanup INT TERM EXIT
  71. #layout the partitons and write filesystem information
  72. create_image() {
  73. dd if=/dev/zero of=$1 bs=$3 count=$4 conv=sparse
  74. parted --script $1 mklabel gpt
  75. cgpt create $1
  76. kernel_start=8192
  77. kernel_size=65536
  78. cgpt add -i 1 -t kernel -b $kernel_start -s $kernel_size -l Kernel -S 1 -T 5 -P 10 $1
  79. #Now the main filesystem
  80. root_start=$(($kernel_start + $kernel_size))
  81. end=`cgpt show $1 | grep 'Sec GPT table' | awk '{print $1}'`
  82. root_size=$(($end - $root_start))
  83. cgpt add -i 2 -t data -b $root_start -s $root_size -l Root $1
  84. # $root_size is in 512 byte blocks while ext4 uses a block size of 1024 bytes
  85. losetup -P $2 $1
  86. mkfs.ext4 -F -b 1024 ${2}p2 $(($root_size / 2))
  87. # mount the / partition
  88. mount -o noatime ${2}p2 $5
  89. }
  90. # create a 2GB image with the Chrome OS partition layout
  91. create_image $BASE $outdev 50M 40 $outmnt
  92. # use default debootstrap mirror if none is specified
  93. if [ "$PRAWNOS_DEBOOTSTRAP_MIRROR" = "" ]
  94. then
  95. PRAWNOS_DEBOOTSTRAP_MIRROR=http://ftp.us.debian.org/debian
  96. fi
  97. # install Debian on it
  98. export DEBIAN_FRONTEND=noninteractive
  99. # need ca-certs, gnupg, openssl to handle https apt links and key adding for deb.prawnos.com
  100. printf -v debootstrap_debs_install_joined '%s,' "${debootstrap_debs_install[@]}"
  101. qemu-debootstrap --arch armhf $DEBIAN_SUITE \
  102. --include ${debootstrap_debs_install_joined%,} \
  103. --keyring=$build_resources/debian-archive-keyring.gpg \
  104. $outmnt \
  105. $PRAWNOS_DEBOOTSTRAP_MIRROR \
  106. --cache-dir=$PRAWNOS_ROOT/build/apt-cache/
  107. chroot $outmnt passwd -d root
  108. #Place the config files and installer script and give them the proper permissions
  109. echo -n PrawnOS > $outmnt/etc/hostname
  110. cp -R $install_resources/ $outmnt/InstallResources/
  111. # and the icons for the lockscreen and app menu
  112. mkdir $outmnt/InstallResources/icons/
  113. cp $build_resources/logo/icons/icon-small.png $outmnt/InstallResources/icons/
  114. cp $build_resources/logo/icons/ascii/* $outmnt/InstallResources/icons/
  115. cp scripts/InstallScripts/* $outmnt/InstallResources/
  116. cp $package_lists $outmnt/InstallResources/
  117. cp scripts/InstallScripts/InstallPrawnOS.sh $outmnt/
  118. chmod +x $outmnt/*.sh
  119. #Setup the chroot for apt
  120. #This is what https://wiki.debian.org/EmDebian/CrossDebootstrap suggests
  121. cp /etc/hosts $outmnt/etc/
  122. cp $build_resources/sources.list $outmnt/etc/apt/sources.list
  123. sed -i -e "s/suite/$DEBIAN_SUITE/g" $outmnt/etc/apt/sources.list
  124. if [ "$DEBIAN_SUITE" != "sid" ]
  125. then
  126. # sid doesn't have updates or security; they're present for all other suites
  127. cat $build_resources/updates.list >> $outmnt/etc/apt/sources.list
  128. sed -i -e "s/suite/$DEBIAN_SUITE/g" $outmnt/etc/apt/sources.list
  129. # sid doesn't have backports; it's present for all other suites
  130. cp $build_resources/backports.list $outmnt/etc/apt/sources.list.d/
  131. sed -i -e "s/suite/$DEBIAN_SUITE/g" $outmnt/etc/apt/sources.list.d/backports.list
  132. #setup apt pinning
  133. cp $build_resources/backports.pref $outmnt/etc/apt/preferences.d/
  134. sed -i -e "s/suite/$DEBIAN_SUITE/g" $outmnt/etc/apt/preferences.d/backports.pref
  135. # Install sid (unstable) as an additional source for bleeding edge packages.
  136. cp $build_resources/sid.list $outmnt/etc/apt/sources.list.d/
  137. #setup apt pinning
  138. cp $build_resources/sid.pref $outmnt/etc/apt/preferences.d/
  139. fi
  140. if [ "$DEBIAN_SUITE" = "buster" ]
  141. then
  142. # Install bullseye (testing) as an additional source
  143. cp $build_resources/bullseye.list $outmnt/etc/apt/sources.list.d/
  144. #setup apt pinning
  145. cp $build_resources/bullseye.pref $outmnt/etc/apt/preferences.d/
  146. fi
  147. #Bring in the deb.prawnos.com gpg keyring
  148. cp $build_resources/deb.prawnos.com.gpg.key $outmnt/InstallResources/
  149. chroot $outmnt apt-key add /InstallResources/deb.prawnos.com.gpg.key
  150. chroot $outmnt apt update
  151. #Setup the locale
  152. cp $build_resources/locale.gen $outmnt/etc/locale.gen
  153. chroot $outmnt locale-gen
  154. #Install the base packages
  155. chroot $outmnt apt update
  156. chroot $outmnt apt install -y ${base_debs_install[@]}
  157. #add the live-boot fstab
  158. cp -f $build_resources/external_fstab $outmnt/etc/fstab
  159. chmod 644 $outmnt/etc/fstab
  160. #Cleanup to reduce install size
  161. chroot $outmnt apt-get autoremove --purge
  162. chroot $outmnt apt-get clean
  163. #Download the shared packages to be installed by Install.sh:
  164. chroot $outmnt apt-get install -y -d ${base_debs_download[@]}
  165. ## DEs
  166. #Download the xfce packages to be installed by Install.sh:
  167. chroot $outmnt apt-get install -y -d ${xfce_debs_download[@]}
  168. #Download the lxqt packages to be installed by Install.sh:
  169. chroot $outmnt apt-get install -y -d ${lxqt_debs_download[@]}
  170. #Download the gnome packages to be installed by Install.sh:
  171. chroot $outmnt apt-get install -y -d ${gnome_debs_download[@]}
  172. # we want to include all of our built packages in the apt cache for installation later, but we want to let apt download dependencies
  173. # if required
  174. # this gets tricky when we build some of the dependencies. To avoid issues
  175. # first, manually cache the deb
  176. # apt install ./local-package.deb alone doesn't work because apt will resort to downloading it from deb.prawnos.com, which we dont want
  177. # copy into /var/cache/apt/archives to place it in the cache
  178. #next call apt install -d on the ./filename or on the package name and apt will recognize it already has the package cached, so will only cache the dependencies
  179. #Copy the built prawnos debs over to the image, and update apts cache
  180. cd $PRAWNOS_ROOT && make packages_install INSTALL_TARGET=$outmnt/var/cache/apt/archives/
  181. chroot $outmnt apt install -y ${prawnos_base_debs_prebuilt_install[@]}
  182. chroot $outmnt apt install -y -d ${prawnos_base_debs_prebuilt_download[@]}
  183. chroot $outmnt apt install -y -d ${prawnos_xfce_debs_prebuilt_download[@]}
  184. ## GPU support
  185. #download mesa packages
  186. chroot $outmnt apt-get install -y -d ${mesa_debs_download[@]}
  187. #Cleanup hosts
  188. rm -rf $outmnt/etc/hosts #This is what https://wiki.debian.org/EmDebian/CrossDebootstrap suggests
  189. echo -n "127.0.0.1 PrawnOS" > $outmnt/etc/hosts
  190. # do a non-error cleanup
  191. umount -l $outmnt > /dev/null 2>&1
  192. rmdir $outmnt > /dev/null 2>&1
  193. losetup -d $outdev > /dev/null 2>&1
  194. echo "DONE!"
  195. trap - INT TERM EXIT